## libmygpo-qt 1.0.2

=== CMakeLists.txt ===
project( libmygpo-qt )

cmake_minimum_required( VERSION 2.6 )

set( CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)
set( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DQT_NO_CAST_FROM_ASCII -DQT_NO_CAST_TO_ASCII" )

find_package( Qt4 COMPONENTS QtCore QtNetwork QtTest REQUIRED )
set( QT_DONT_USE_QTGUI TRUE )

find_package(QJSON REQUIRED)

include( ${QT_USE_FILE} )

set( MYGPO_LIB_MAJOR_VERSION "1" )
set( MYGPO_LIB_MINOR_VERSION "0" )
set( MYGPO_LIB_PATCH_VERSION "2" )
set( MYGPO_LIB_VERSION "${MYGPO_LIB_MAJOR_VERSION}.${MYGPO_LIB_MINOR_VERSION}.${MYGPO_LIB_PATCH_VERSION}" )

set( MYGPO_LIB_VERSION_SONAME "${MYGPO_LIB_MAJOR_VERSION}")

if (CMAKE_COMPILER_IS_GNUCXX)
    ADD_DEFINITIONS( -Wcast-align -Wchar-subscripts -Wpointer-arith
       -Wwrite-strings -Wpacked -Wformat-security -Wmissing-format-attribute
       -Wold-style-cast -Woverloaded-virtual -Wnon-virtual-dtor  -Wall -Wextra
       -Wformat=2 -Wundef -Wlogical-op -Wstack-protector -Wmissing-include-dirs
       -Winit-self -Wunsafe-loop-optimizations  -ggdb3 -fno-inline -DQT_STRICT_ITERATORS )
    if ( NOT WIN32 )
        add_definitions( -fvisibility=hidden )
    endif()
endif(CMAKE_COMPILER_IS_GNUCXX)

option(MYGPO_BUILD_TESTS "Build all unit tests" ON)

if(MYGPO_BUILD_TESTS)
  enable_testing()
endif(MYGPO_BUILD_TESTS)

set( CPACK_GENERATOR "TBZ2" "DEB" )
set( CPACK_PACKAGE_VERSION_MAJOR "${MYGPO_LIB_MAJOR_VERSION}" )
set( CPACK_PACKAGE_VERSION_MINOR "${MYGPO_LIB_MINOR_VERSION}" )
set( CPACK_PACKAGE_VERSION_PATCH "${MYGPO_LIB_PATCH_VERSION}" )
set( CPACK_PACKAGE_VERSION "${MYGPO_LIB_VERSION}" )
set( CPACK_DEBIAN_PACKAGE_MAINTAINER "gpodder-devel@lists.berlios.de" )
set( CPACK_PACKAGE_DESCRIPTION_SUMMARY "A c++/qt library to access the APIs provided by gpodder.net." )

if( APPLE )
    set( CPACK_GENERATOR "DragNDrop" )
    set( CPACK_DMG_FORMAT "UDBZ" )
    set( CPACK_DMG_VOLUME_NAME "libmygpo-qt" )
    set( CPACK_SYSTEM_NAME "OSX" )
endif( APPLE )

include(CPack)

# add a target to generate API documentation with Doxygen
find_package(Doxygen)
if(DOXYGEN_FOUND)
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile @ONLY)
    add_custom_target(doc ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR} 
                         COMMENT "Generating API documentation with Doxygen" VERBATIM
)
endif(DOXYGEN_FOUND)

# make uninstall support
CONFIGURE_FILE(
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
  IMMEDIATE @ONLY)

ADD_CUSTOM_TARGET(uninstall
  "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

#add extra search paths for libraries and includes
SET (LIB_SUFFIX "" CACHE STRING "Define suffix of directory name (32/64)" )
SET (LIB_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}" CACHE STRING "Directory where lib will install")
SET (INCLUDE_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/include/mygpo-qt" CACHE PATH "The directory the headers are installed in")
# SET (CMAKE_MODULES_INSTALL_DIR "${CMAKE_ROOT}/Modules" CACHE PATH "The directory to install FindLibmygpo-qt.cmake to")

# pkg-config
find_package(PkgConfig)
IF (NOT WIN32)
    IF (PKG_CONFIG_FOUND)
        CONFIGURE_FILE (${CMAKE_CURRENT_SOURCE_DIR}/libmygpo-qt.pc.in
                            ${CMAKE_CURRENT_BINARY_DIR}/libmygpo-qt.pc
                            @ONLY)
         INSTALL (FILES ${CMAKE_CURRENT_BINARY_DIR}/libmygpo-qt.pc DESTINATION lib${LIB_SUFFIX}/pkgconfig)
    ENDIF (PKG_CONFIG_FOUND)
ENDIF (NOT WIN32)

add_subdirectory( src )
if(MYGPO_BUILD_TESTS)
    add_subdirectory( tests )
endif(MYGPO_BUILD_TESTS)

=== src/CMakeLists.txt ===

include_directories( ${QT_INCLUDES} ${QJSON_INCLUDE_DIR} ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR} )

set ( LIBMYGPO_QT_SRC
        Settings.cpp
        AddRemoveResult.cpp
        Tag.cpp 
        JsonCreator.cpp 
        Podcast.cpp
        Episode.cpp 
        EpisodeAction.cpp
        EpisodeActionList.cpp
        ApiRequest.cpp
        RequestHandler.cpp
        UrlBuilder.cpp
        TagList.cpp
        EpisodeList.cpp
        PodcastList.cpp
        DeviceUpdates.cpp
        DeviceList.cpp
        Device.cpp
)

set ( LIBMYGPO_QT_MOC_H
        Podcast.h
        PodcastList.h
        Episode.h
        EpisodeList.h
        Tag.h
        TagList.h
        Device.h
        DeviceList.h
        DeviceUpdates.h
        EpisodeAction.h
        EpisodeActionList.h
        Settings.h
        AddRemoveResult.h
)

set ( LIBMYGPO_QT_INSTALL_H
        ApiRequest.h
        mygpo_export.h
        Podcast.h
        PodcastList.h
        Episode.h
        EpisodeList.h
        Tag.h
        TagList.h
        Device.h
        DeviceList.h
        DeviceUpdates.h
        EpisodeAction.h
        EpisodeActionList.h
        Settings.h
        AddRemoveResult.h
)

QT4_WRAP_CPP(LIBMYGPO_QT_MOC_SRC ${LIBMYGPO_QT_MOC_H} )

QT4_GENERATE_MOC(PodcastList.cpp PodcastList.moc)
QT4_GENERATE_MOC(EpisodeList.cpp EpisodeList.moc)
QT4_GENERATE_MOC(Episode.cpp Episode.moc)
QT4_GENERATE_MOC(EpisodeAction.cpp EpisodeAction.moc)
QT4_GENERATE_MOC(EpisodeActionList.cpp EpisodeActionList.moc)
QT4_GENERATE_MOC(Podcast.cpp Podcast.moc)
QT4_GENERATE_MOC(AddRemoveResult.cpp AddRemoveResult.moc)
QT4_GENERATE_MOC(TagList.cpp TagList.moc)
QT4_GENERATE_MOC(Tag.cpp Tag.moc)
QT4_GENERATE_MOC(Settings.cpp Settings.moc)
QT4_GENERATE_MOC(DeviceUpdates.cpp DeviceUpdates.moc)
QT4_GENERATE_MOC(DeviceList.cpp DeviceList.moc)
QT4_GENERATE_MOC(Device.cpp Device.moc)

add_library( mygpo-qt SHARED ${LIBMYGPO_QT_SRC} ${LIBMYGPO_QT_MOC_SRC} PodcastList.moc EpisodeList.moc Episode.moc EpisodeAction.moc EpisodeActionList.moc Podcast.moc AddRemoveResult.moc TagList.moc Tag.moc Settings.moc DeviceUpdates.moc DeviceList.moc Device.moc)

target_link_libraries( mygpo-qt ${QJSON_LIBRARIES} ${QT_QTCORE_LIBRARY} ${QT_QTNETWORK_LIBRARY}  )
set_target_properties( mygpo-qt PROPERTIES VERSION ${MYGPO_LIB_VERSION} SOVERSION ${MYGPO_LIB_VERSION_SONAME} DEFINE_SYMBOL MYGPO_MAKEDLL)
install( TARGETS mygpo-qt DESTINATION lib${LIB_SUFFIX} )

install( FILES ${LIBMYGPO_QT_INSTALL_H} DESTINATION  include/mygpo-qt COMPONENT Devel )

=== tests/CMakeLists.txt ===
########### next target ###############
# QTEST_MAIN is using QApplication when QT_GUI_LIB is defined
remove_definitions(-DQT_GUI_LIB)
remove_definitions(-fvisibility=hidden)

set ( TESTOBJECTS_SRCDIR ${CMAKE_CURRENT_SOURCE_DIR}/../src )

include_directories( ${QT_INCLUDES} ${QJSON_INCLUDE_DIR} ${CMAKE_CURRENT_BINARY_DIR} ${TESTOBJECTS_SRCDIR} )

# RequestHandler library
add_library( RequestHandler ${TESTOBJECTS_SRCDIR}/RequestHandler.cpp )

# UrlBuilder library
add_library( UrlBuilder ${TESTOBJECTS_SRCDIR}/UrlBuilder.cpp )

set( EXECUTABLE_OUTPUT_PATH ${CMAKE_CURRENT_BINARY_DIR} )

macro(add_libmygpo_test _source)
    get_filename_component(_name ${_source} NAME_WE)
    QT4_WRAP_CPP(${_name}_MOC_SRC ${_name}.h)
    add_executable(${_name} ${_source} ${${_name}_MOC_SRC})
    target_link_libraries(${_name} ${QT_QTCORE_LIBRARY} ${QT_QTTEST_LIBRARY} ${QTCORE_QTNETWORK_LIBRARY})
    add_test(${_name}-test ${EXECUTABLE_OUTPUT_PATH}/${_name})
endmacro(add_libmygpo_test)

add_libmygpo_test( UrlBuilderTest.cpp )
target_link_libraries( UrlBuilderTest UrlBuilder)

add_libmygpo_test( RequestHandlerTest.cpp )
target_link_libraries(RequestHandlerTest RequestHandler)

=== debian/changelog ===
libmygpo-qt (1.0.2-0ubuntu1) natty; urgency=low

  * Initial release, LP: #744512

 -- Romain Perier <romain.perier@gmail.com>  Tue, 22 Mar 2011 09:05:06 +0100

=== debian/control ===
Source: libmygpo-qt
Section: kde
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Romain Perier <romain.perier@gmail.com>
Build-Depends: debhelper (>= 7.0.50~), cmake (>= 2.6), pkg-config, libqjson-dev, libqt4-dev
Standards-Version: 3.9.1
Homepage: http://wiki.gpodder.org/wiki/Libmygpo-qt

Package: libmygpo-qt-dev
Section: libdevel
Architecture: any
Depends: libmygpo-qt1 (= ${binary:Version}), ${misc:Depends}, libqjson-dev, libqt4-dev
Description: Development headers for the mygpo-qt library
 C++/Qt Library wrapping the gpodder.net Webservice
 .
 This package contains the development headers for the mygpo-qt library

Package: libmygpo-qt1
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: mygpo-qt library package
 C++/Qt Library wrapping the gpodder.net Webservice
 .
 This package contains the myqpo-qt library

## libmygpo-qt 1.0.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -14,7 +14,7 @@
 
 set( MYGPO_LIB_MAJOR_VERSION "1" )
 set( MYGPO_LIB_MINOR_VERSION "0" )
-set( MYGPO_LIB_PATCH_VERSION "2" )
+set( MYGPO_LIB_PATCH_VERSION "3" )
 set( MYGPO_LIB_VERSION "${MYGPO_LIB_MAJOR_VERSION}.${MYGPO_LIB_MINOR_VERSION}.${MYGPO_LIB_PATCH_VERSION}" )
 
 set( MYGPO_LIB_VERSION_SONAME "${MYGPO_LIB_MAJOR_VERSION}")

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -23,18 +23,31 @@
 
 set ( LIBMYGPO_QT_MOC_H
         Podcast.h
+        Podcast_p.h
         PodcastList.h
+        PodcastList_p.h
         Episode.h
+        Episode_p.h
         EpisodeList.h
+        EpisodeList_p.h
         Tag.h
+        Tag_p.h
         TagList.h
+        TagList_p.h
         Device.h
+        Device_p.h
         DeviceList.h
+        DeviceList_p.h
         DeviceUpdates.h
+        DeviceUpdates_p.h
         EpisodeAction.h
+        EpisodeAction_p.h
         EpisodeActionList.h
+        EpisodeActionList_p.h
         Settings.h
+        Settings_p.h
         AddRemoveResult.h
+        AddRemoveResult_p.h
 )
 
 set ( LIBMYGPO_QT_INSTALL_H
@@ -57,21 +70,7 @@
 
 QT4_WRAP_CPP(LIBMYGPO_QT_MOC_SRC ${LIBMYGPO_QT_MOC_H} )
 
-QT4_GENERATE_MOC(PodcastList.cpp PodcastList.moc)
-QT4_GENERATE_MOC(EpisodeList.cpp EpisodeList.moc)
-QT4_GENERATE_MOC(Episode.cpp Episode.moc)
-QT4_GENERATE_MOC(EpisodeAction.cpp EpisodeAction.moc)
-QT4_GENERATE_MOC(EpisodeActionList.cpp EpisodeActionList.moc)
-QT4_GENERATE_MOC(Podcast.cpp Podcast.moc)
-QT4_GENERATE_MOC(AddRemoveResult.cpp AddRemoveResult.moc)
-QT4_GENERATE_MOC(TagList.cpp TagList.moc)
-QT4_GENERATE_MOC(Tag.cpp Tag.moc)
-QT4_GENERATE_MOC(Settings.cpp Settings.moc)
-QT4_GENERATE_MOC(DeviceUpdates.cpp DeviceUpdates.moc)
-QT4_GENERATE_MOC(DeviceList.cpp DeviceList.moc)
-QT4_GENERATE_MOC(Device.cpp Device.moc)
-
-add_library( mygpo-qt SHARED ${LIBMYGPO_QT_SRC} ${LIBMYGPO_QT_MOC_SRC} PodcastList.moc EpisodeList.moc Episode.moc EpisodeAction.moc EpisodeActionList.moc Podcast.moc AddRemoveResult.moc TagList.moc Tag.moc Settings.moc DeviceUpdates.moc DeviceList.moc Device.moc)
+add_library( mygpo-qt SHARED ${LIBMYGPO_QT_SRC} ${LIBMYGPO_QT_MOC_SRC} )
 
 target_link_libraries( mygpo-qt ${QJSON_LIBRARIES} ${QT_QTCORE_LIBRARY} ${QT_QTNETWORK_LIBRARY}  )
 set_target_properties( mygpo-qt PROPERTIES VERSION ${MYGPO_LIB_VERSION} SOVERSION ${MYGPO_LIB_VERSION_SONAME} DEFINE_SYMBOL MYGPO_MAKEDLL)

=== cmake/modules/CMakeLists.txt ===


set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR})
find_package(libmygpo-qt REQUIRED)

=== debian/changelog ===
libmygpo-qt (1.0.3-0ubuntu1) oneiric; urgency=low

  * New upstream release

 -- Romain Perier <romain.perier@gmail.com>  Tue, 24 May 2011 20:19:25 +0200

## libmygpo-qt 1.0.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
+cmake_minimum_required( VERSION 2.6 FATAL_ERROR )
+
 project( libmygpo-qt )
-
-cmake_minimum_required( VERSION 2.6 )
 
 set( CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)
 set( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DQT_NO_CAST_FROM_ASCII -DQT_NO_CAST_TO_ASCII" )
@@ -12,12 +12,12 @@
 
 include( ${QT_USE_FILE} )
 
-set( MYGPO_LIB_MAJOR_VERSION "1" )
-set( MYGPO_LIB_MINOR_VERSION "0" )
-set( MYGPO_LIB_PATCH_VERSION "3" )
-set( MYGPO_LIB_VERSION "${MYGPO_LIB_MAJOR_VERSION}.${MYGPO_LIB_MINOR_VERSION}.${MYGPO_LIB_PATCH_VERSION}" )
+set( MYGPO_QT_VERSION_MAJOR "1" )
+set( MYGPO_QT_VERSION_MINOR "0" )
+set( MYGPO_QT_VERSION_PATCH "5" )
+set( MYGPO_QT_VERSION "${MYGPO_QT_VERSION_MAJOR}.${MYGPO_QT_VERSION_MINOR}.${MYGPO_QT_VERSION_PATCH}" )
 
-set( MYGPO_LIB_VERSION_SONAME "${MYGPO_LIB_MAJOR_VERSION}")
+set( MYGPO_QT_SONAME "${MYGPO_QT_VERSION_MAJOR}")
 
 if (CMAKE_COMPILER_IS_GNUCXX)
     ADD_DEFINITIONS( -Wcast-align -Wchar-subscripts -Wpointer-arith
@@ -33,16 +33,23 @@
 option(MYGPO_BUILD_TESTS "Build all unit tests" ON)
 
 if(MYGPO_BUILD_TESTS)
-  enable_testing()
+    INCLUDE(CTest)
+    enable_testing()
 endif(MYGPO_BUILD_TESTS)
 
 set( CPACK_GENERATOR "TBZ2" "DEB" )
-set( CPACK_PACKAGE_VERSION_MAJOR "${MYGPO_LIB_MAJOR_VERSION}" )
-set( CPACK_PACKAGE_VERSION_MINOR "${MYGPO_LIB_MINOR_VERSION}" )
-set( CPACK_PACKAGE_VERSION_PATCH "${MYGPO_LIB_PATCH_VERSION}" )
-set( CPACK_PACKAGE_VERSION "${MYGPO_LIB_VERSION}" )
-set( CPACK_DEBIAN_PACKAGE_MAINTAINER "gpodder-devel@lists.berlios.de" )
+set( CPACK_PACKAGE_VERSION_MAJOR "${MYGPO_QT_VERSION_MAJOR}" )
+set( CPACK_PACKAGE_VERSION_MINOR "${MYGPO_QT_VERSION_MINOR}" )
+set( CPACK_PACKAGE_VERSION_PATCH "${MYGPO_QT_VERSION_PATCH}" )
+set( CPACK_PACKAGE_VERSION "${MYGPO_QT_VERSION}" )
+set( CPACK_DEBIAN_PACKAGE_MAINTAINER "gpodder@freelists.org" )
 set( CPACK_PACKAGE_DESCRIPTION_SUMMARY "A c++/qt library to access the APIs provided by gpodder.net." )
+
+set(LIB_INSTALL_DIR_SUFFIX "" CACHE STRING "The directories where to install libraries to")
+set(LIB_INSTALL_DIR lib${LIB_INSTALL_DIR_SUFFIX} )
+set(INCLUDE_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/include/mygpo-qt" CACHE PATH "The directory the headers are installed in")
+set(CMAKECONFIG_INSTALL_DIR ${LIB_INSTALL_DIR}/cmake/mygpo-qt ) 
+# SET (CMAKE_MODULES_INSTALL_DIR "${CMAKE_ROOT}/Modules" CACHE PATH "The directory to install FindLibmygpo-qt.cmake to")
 
 if( APPLE )
     set( CPACK_GENERATOR "DragNDrop" )
@@ -71,12 +78,6 @@
 ADD_CUSTOM_TARGET(uninstall
   "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")
 
-#add extra search paths for libraries and includes
-SET (LIB_SUFFIX "" CACHE STRING "Define suffix of directory name (32/64)" )
-SET (LIB_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}" CACHE STRING "Directory where lib will install")
-SET (INCLUDE_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/include/mygpo-qt" CACHE PATH "The directory the headers are installed in")
-# SET (CMAKE_MODULES_INSTALL_DIR "${CMAKE_ROOT}/Modules" CACHE PATH "The directory to install FindLibmygpo-qt.cmake to")
-
 # pkg-config
 find_package(PkgConfig)
 IF (NOT WIN32)
@@ -92,3 +93,29 @@
 if(MYGPO_BUILD_TESTS)
     add_subdirectory( tests )
 endif(MYGPO_BUILD_TESTS)
+
+# This "exports" all targets which have been put into the export set "BarExport".
+# This means that cmake generates a file with the given filename, which can later on be loaded
+# by projects using this package.
+# This file contains add_library(bar IMPORTED) statements for each target in the export set, so
+# when loaded later on cmake will create "imported" library targets from these, which can be used
+# in many ways in the same way as a normal library target created via a normal add_library().
+install(EXPORT mygpo-qtExport DESTINATION ${CMAKECONFIG_INSTALL_DIR} FILE Mygpo-qtTargets.cmake )
+
+# figure out the relative path from the installed Config.cmake file to the install prefix (which may be at
+# runtime different from the chosen CMAKE_INSTALL_PREFIX if under Windows the package was installed anywhere)
+# This relative path will be configured into the BarConfig.cmake
+file(RELATIVE_PATH relInstallDir ${CMAKE_INSTALL_PREFIX}/${CMAKECONFIG_INSTALL_DIR} ${CMAKE_INSTALL_PREFIX} )
+
+# Create a BarConfig.cmake file. <name>Config.cmake files are searched by find_package()
+# automatically. We configure that file so that we can put any information we want in it,
+# e.g. version numbers, include directories, etc.
+configure_file(Mygpo-qtConfig.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/Mygpo-qtConfig.cmake @ONLY )
+
+# Additionally, when cmake has found a BarConfig.cmake, it can check for a BarConfigVersion.cmake
+# in the same directory when figuring out the version of the package when a version
+# has been specified in the find_package() call, e.g. find_package(Bar 1.0)
+configure_file(Mygpo-qtConfigVersion.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/Mygpo-qtConfigVersion.cmake @ONLY )
+
+# Install these two files into the same directory as the generated exports-file.
+install(FILES ${CMAKE_CURRENT_BINARY_DIR}/Mygpo-qtConfig.cmake ${CMAKE_CURRENT_BINARY_DIR}/Mygpo-qtConfigVersion.cmake DESTINATION ${CMAKECONFIG_INSTALL_DIR} )

=== tests/CMakeLists.txt ===
########### next target ###############
# QTEST_MAIN is using QApplication when QT_GUI_LIB is defined
remove_definitions(-DQT_GUI_LIB)
remove_definitions(-fvisibility=hidden)

set ( TESTOBJECTS_SRCDIR ${CMAKE_CURRENT_SOURCE_DIR}/../src )

include_directories( ${QT_INCLUDES} ${QJSON_INCLUDE_DIR} ${CMAKE_CURRENT_BINARY_DIR} ${TESTOBJECTS_SRCDIR} )

# UrlBuilder library
add_library( UrlBuilder ${TESTOBJECTS_SRCDIR}/UrlBuilder.cpp )

set( EXECUTABLE_OUTPUT_PATH ${CMAKE_CURRENT_BINARY_DIR} )

macro(add_libmygpo_test _source)
    get_filename_component(_name ${_source} NAME_WE)
    QT4_WRAP_CPP(${_name}_MOC_SRC ${_name}.h)
    add_executable(${_name} ${_source} ${${_name}_MOC_SRC})
    target_link_libraries(${_name} ${QT_QTCORE_LIBRARY} ${QT_QTTEST_LIBRARY} ${QT_QTNETWORK_LIBRARY})
    add_test(${_name}-test ${EXECUTABLE_OUTPUT_PATH}/${_name})
endmacro(add_libmygpo_test)

add_libmygpo_test( UrlBuilderTest.cpp )
target_link_libraries( UrlBuilderTest UrlBuilder)

=== debian/changelog ===
libmygpo-qt (1.0.5-0ubuntu1) precise; urgency=low

  * New upstream release

 -- Jonathan Riddell <jriddell@ubuntu.com>  Mon, 14 Nov 2011 20:42:53 +0000

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Romain Perier <romain.perier@gmail.com>
 Build-Depends: debhelper (>= 7.0.50~), cmake (>= 2.6), pkg-config, libqjson-dev, libqt4-dev
-Standards-Version: 3.9.1
+Standards-Version: 3.9.2
 Homepage: http://wiki.gpodder.org/wiki/Libmygpo-qt
 
 Package: libmygpo-qt-dev

## libmygpo-qt 1.0.6

=== debian/changelog ===
libmygpo-qt (1.0.6-0ubuntu1) raring; urgency=low

  [ Michal Zajac ]
  * New upstream release
  * Updated symbols files

  [ Philip Muškovac ]
  * Use pkg-kde-tools for substition support in libmygpo-qt1.symbols 

 -- Michal Zajac <quintasan@kubuntu.org>  Thu, 18 Oct 2012 14:01:44 +0200

## libmygpo-qt 1.0.7

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,6 +4,10 @@
 
 set( CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)
 set( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DQT_NO_CAST_FROM_ASCII -DQT_NO_CAST_TO_ASCII" )
+
+# Don't use absolute path in Mygpo-qtTargets-$buildType.cmake
+# (This will have no effect with CMake < 2.8)
+set(QT_USE_IMPORTED_TARGETS TRUE)
 
 find_package( Qt4 COMPONENTS QtCore QtNetwork QtTest REQUIRED )
 set( QT_DONT_USE_QTGUI TRUE )
@@ -14,19 +18,29 @@
 
 set( MYGPO_QT_VERSION_MAJOR "1" )
 set( MYGPO_QT_VERSION_MINOR "0" )
-set( MYGPO_QT_VERSION_PATCH "5" )
+set( MYGPO_QT_VERSION_PATCH "7" )
 set( MYGPO_QT_VERSION "${MYGPO_QT_VERSION_MAJOR}.${MYGPO_QT_VERSION_MINOR}.${MYGPO_QT_VERSION_PATCH}" )
 
 set( MYGPO_QT_SONAME "${MYGPO_QT_VERSION_MAJOR}")
+
+#Configure Version.h.in with the actual version number
+configure_file( src/Version.h.in ${CMAKE_CURRENT_BINARY_DIR}/src/Version.h )
+
+include(CheckCXXCompilerFlag)
 
 if (CMAKE_COMPILER_IS_GNUCXX)
     ADD_DEFINITIONS( -Wcast-align -Wchar-subscripts -Wpointer-arith
        -Wwrite-strings -Wpacked -Wformat-security -Wmissing-format-attribute
        -Wold-style-cast -Woverloaded-virtual -Wnon-virtual-dtor  -Wall -Wextra
-       -Wformat=2 -Wundef -Wlogical-op -Wstack-protector -Wmissing-include-dirs
+       -Wformat=2 -Wundef -Wstack-protector -Wmissing-include-dirs
        -Winit-self -Wunsafe-loop-optimizations  -ggdb3 -fno-inline -DQT_STRICT_ITERATORS )
     if ( NOT WIN32 )
         add_definitions( -fvisibility=hidden )
+    endif()
+
+    check_cxx_compiler_flag( -Wlogical-op GNUCXX_HAS_WLOGICAL_OP )
+    if ( GNUCXX_HAS_WLOGICAL_OP )
+        add_definitions( -Wlogical-op )
     endif()
 endif(CMAKE_COMPILER_IS_GNUCXX)
 
@@ -45,11 +59,11 @@
 set( CPACK_DEBIAN_PACKAGE_MAINTAINER "gpodder@freelists.org" )
 set( CPACK_PACKAGE_DESCRIPTION_SUMMARY "A c++/qt library to access the APIs provided by gpodder.net." )
 
-set(LIB_INSTALL_DIR_SUFFIX "" CACHE STRING "The directories where to install libraries to")
-set(LIB_INSTALL_DIR lib${LIB_INSTALL_DIR_SUFFIX} )
+set(LIB_SUFFIX "" CACHE STRING "The directories where to install libraries to")
+set(LIB_INSTALL_DIR lib${LIB_SUFFIX} )
+set(LIB_DIR_PKGCONF "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}")
 set(INCLUDE_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/include/mygpo-qt" CACHE PATH "The directory the headers are installed in")
-set(CMAKECONFIG_INSTALL_DIR ${LIB_INSTALL_DIR}/cmake/mygpo-qt ) 
-# SET (CMAKE_MODULES_INSTALL_DIR "${CMAKE_ROOT}/Modules" CACHE PATH "The directory to install FindLibmygpo-qt.cmake to")
+set(CMAKECONFIG_INSTALL_DIR ${LIB_INSTALL_DIR}/cmake/mygpo-qt )
 
 if( APPLE )
     set( CPACK_GENERATOR "DragNDrop" )
@@ -79,8 +93,8 @@
   "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")
 
 # pkg-config
-find_package(PkgConfig)
 IF (NOT WIN32)
+    FIND_PACKAGE(PkgConfig)
     IF (PKG_CONFIG_FOUND)
         CONFIGURE_FILE (${CMAKE_CURRENT_SOURCE_DIR}/libmygpo-qt.pc.in
                             ${CMAKE_CURRENT_BINARY_DIR}/libmygpo-qt.pc

=== example/Makefile ===
CC=g++
CFLAGS=-c -g -Wall $(shell pkg-config QtGui QtCore QtNetwork libmygpo-qt --cflags)
LIBS= $(shell pkg-config QtGui QtCore QtNetwork libmygpo-qt --libs)
SRCDIR=src

all: main

main: $(SRCDIR)/main.o 
	$(CC) $(SRCDIR)/main.o -o main $(LIBS)

$(SRCDIR)/main.o: $(SRCDIR)/main.cpp
	$(CC) $(CFLAGS) $(SRCDIR)/main.cpp -o $(SRCDIR)/main.o


make clean:
	rm -fr $(SRCDIR)/*.moc $(SRCDIR)/*.o main

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -2,6 +2,8 @@
 include_directories( ${QT_INCLUDES} ${QJSON_INCLUDE_DIR} ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR} )
 
 set ( LIBMYGPO_QT_SRC
+        Config.cpp
+        DeviceSyncResult.cpp
         Settings.cpp
         AddRemoveResult.cpp
         Tag.cpp 
@@ -38,6 +40,8 @@
         Device_p.h
         DeviceList.h
         DeviceList_p.h
+        DeviceSyncResult.h
+        DeviceSyncResult_p.h
         DeviceUpdates.h
         DeviceUpdates_p.h
         EpisodeAction.h
@@ -53,6 +57,7 @@
 set ( LIBMYGPO_QT_INSTALL_H
         ApiRequest.h
         mygpo_export.h
+        Config.h
         Podcast.h
         PodcastList.h
         Episode.h
@@ -61,6 +66,7 @@
         TagList.h
         Device.h
         DeviceList.h
+        DeviceSyncResult.h
         DeviceUpdates.h
         EpisodeAction.h
         EpisodeActionList.h
@@ -73,7 +79,7 @@
 add_library( mygpo-qt SHARED ${LIBMYGPO_QT_SRC} ${LIBMYGPO_QT_MOC_SRC} )
 
 target_link_libraries( mygpo-qt ${QJSON_LIBRARIES} ${QT_QTCORE_LIBRARY} ${QT_QTNETWORK_LIBRARY}  )
-set_target_properties( mygpo-qt PROPERTIES VERSION ${MYGPO_LIB_VERSION} SOVERSION ${MYGPO_LIB_VERSION_SONAME} DEFINE_SYMBOL MYGPO_MAKEDLL)
-install( TARGETS mygpo-qt DESTINATION lib${LIB_SUFFIX} )
+set_target_properties( mygpo-qt PROPERTIES VERSION ${MYGPO_QT_VERSION} SOVERSION ${MYGPO_QT_SONAME} DEFINE_SYMBOL MYGPO_MAKEDLL)
+install( TARGETS mygpo-qt EXPORT mygpo-qtExport DESTINATION lib${LIB_SUFFIX} )
 
 install( FILES ${LIBMYGPO_QT_INSTALL_H} DESTINATION  include/mygpo-qt COMPONENT Devel )

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -2,13 +2,18 @@
 # QTEST_MAIN is using QApplication when QT_GUI_LIB is defined
 remove_definitions(-DQT_GUI_LIB)
 remove_definitions(-fvisibility=hidden)
+remove_definitions(-DQT_NO_CAST_FROM_ASCII)
+remove_definitions(-DQT_NO_CAST_TO_ASCII)
 
 set ( TESTOBJECTS_SRCDIR ${CMAKE_CURRENT_SOURCE_DIR}/../src )
 
-include_directories( ${QT_INCLUDES} ${QJSON_INCLUDE_DIR} ${CMAKE_CURRENT_BINARY_DIR} ${TESTOBJECTS_SRCDIR} )
+include_directories( ${QT_INCLUDES} ${QJSON_INCLUDE_DIR} ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_BINARY_DIR}/../src ${TESTOBJECTS_SRCDIR} )
 
 # UrlBuilder library
-add_library( UrlBuilder ${TESTOBJECTS_SRCDIR}/UrlBuilder.cpp )
+add_library( UrlBuilder ${TESTOBJECTS_SRCDIR}/UrlBuilder.cpp ${TESTOBJECTS_SRCDIR}/Config.cpp )
+# JSONCreator library
+QT4_WRAP_CPP(LIBMYGPO_QT_MOC_SRC ${TESTOBJECTS_SRCDIR}/EpisodeAction.h ${TESTOBJECTS_SRCDIR}/EpisodeAction_p.h )
+add_library( JsonCreator ${TESTOBJECTS_SRCDIR}/JsonCreator.cpp ${TESTOBJECTS_SRCDIR}/EpisodeAction.cpp ${LIBMYGPO_QT_MOC_SRC})
 
 set( EXECUTABLE_OUTPUT_PATH ${CMAKE_CURRENT_BINARY_DIR} )
 
@@ -22,3 +27,6 @@
 
 add_libmygpo_test( UrlBuilderTest.cpp )
 target_link_libraries( UrlBuilderTest UrlBuilder)
+
+add_libmygpo_test( JsonCreatorTest.cpp )
+target_link_libraries( JsonCreatorTest JsonCreator ${QJSON_LIBRARIES} )

=== debian/changelog ===
libmygpo-qt (1.0.7-0ubuntu2) saucy; urgency=low

  * Fix install files to fix archive rebuild failiure
  * Update symbols

 -- Rohan Garg <rohangarg@kubuntu.org>  Fri, 04 Oct 2013 21:36:16 +0200

libmygpo-qt (1.0.7-0ubuntu1) saucy; urgency=low

  * New upstream release 
  * Add new symbols to libmygpo-qt1.symbols
  * Fix copyright file syntax

 -- Philip Muškovac <yofel@kubuntu.org>  Tue, 30 Apr 2013 17:20:51 +0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,8 @@
 Priority: optional
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Romain Perier <romain.perier@gmail.com>
-Build-Depends: debhelper (>= 7.0.50~), cmake (>= 2.6), pkg-config, libqjson-dev, libqt4-dev
+Build-Depends: debhelper (>= 7.0.50~), cmake (>= 2.6), pkg-config, libqjson-dev,
+ libqt4-dev, pkg-kde-tools
 Standards-Version: 3.9.2
 Homepage: http://wiki.gpodder.org/wiki/Libmygpo-qt

=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@ --with pkgkde_symbolshelper

## libmygpo-qt 1.0.9~git20151122

=== debian/changelog ===
libmygpo-qt (1.0.9~git20151122-1~bpo8) jessie; urgency=medium

  * Repackaged for Debian 8 (Jessie).

 -- Mike Elstad (v3g4n) <maintainer@mepiscommunity.org>  Mon, 14 Mar 2016 19:16:45 -0500

libmygpo-qt (1.0.9~git20151122-1) unstable; urgency=low

  * Import package from Ubuntu. Thanks to everyone involved so far.
  * Set myself as Maintainer for the Debian package.
  * New upstream snapshot.
  * Add debian/watch file.
  * Update debian/copyright.
  * Add Vcs-* fields to debian/control.
  * Bump debhelper compat level.
  * Add a patch to fix a reference string in the tests.
  * Implement Multi-Arch support.
  * Ship code example in dev package.
  * Bump Standards-Version.

 -- Jérémy Bobbio <lunar@debian.org>  Mon, 25 Jan 2016 22:42:46 +0100

=== debian/control ===
Source: libmygpo-qt
Section: kde
Priority: optional
Maintainer: Mike Elstad (v3g4n) <maintainer@mepiscommunity.org>
XSBC-Original-Maintainer: Jérémy Bobbio <lunar@debian.org>
Bugs: mailto: <maintainer@mepiscommunity.org>
Build-Depends: debhelper (>= 9), cmake (>= 2.6), pkg-config, libqjson-dev,
 libqt4-dev, pkg-kde-tools
Standards-Version: 3.9.6
Vcs-Git: https://anonscm.debian.org/git/collab-maint/libmygpo-qt.git
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/libmygpo-qt.git
Homepage: http://wiki.gpodder.org/wiki/Libmygpo-qt

Package: libmygpo-qt-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libmygpo-qt1 (= ${binary:Version}), ${misc:Depends}, libqjson-dev, libqt4-dev
Description: Development headers for the mygpo-qt library
 C++/Qt Library wrapping the gpodder.net Webservice
 .
 This package contains the development headers for the mygpo-qt library

Package: libmygpo-qt1
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: mygpo-qt library package
 C++/Qt Library wrapping the gpodder.net Webservice
 .
 This package contains the myqpo-qt library

## libmygpo-qt 1.0.9

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,20 +5,56 @@
 set( CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)
 set( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DQT_NO_CAST_FROM_ASCII -DQT_NO_CAST_TO_ASCII" )
 
+option(BUILD_WITH_QT4 "Build libmygpo-qt with Qt4 no matter if Qt5 was found" ON)
+
+if( NOT BUILD_WITH_QT4 )
+    find_package(Qt5Core QUIET)
+    if( Qt5Core_DIR )
+        message(STATUS "Found Qt5! Be aware that Qt5-support is still experimental and not officially supported!")
+        set(MYGPO_QT_VERSION_SUFFIX 5)
+
+        macro(qt_wrap_cpp)
+            qt5_wrap_cpp(${ARGN})
+        endmacro()
+    endif()
+
+    # pkg-config names of QtCore and QtNetwork are Qt5Core and Qt5Network for
+    # Qt5
+    set(MYGPO_QT_MAJOR_VERSION "5")
+    set(MYGPO_QT4_QJSON_DEP "")
+endif()
+
+if( NOT Qt5Core_DIR )
+    message(STATUS "Could not find Qt5, searching for Qt4 instead...")
+    if( MYGPO_BUILD_TESTS )
+        find_package( Qt4 COMPONENTS QtCore QtNetwork QtTest REQUIRED )
+    else( MYGPO_BUILD_TESTS )
+        find_package( Qt4 COMPONENTS QtCore QtNetwork REQUIRED )
+    endif()
+    set( QT_DONT_USE_QTGUI TRUE )
+    include( ${QT_USE_FILE} )
+
+    macro(qt5_use_modules)
+    endmacro()
+
+    macro(qt_wrap_cpp)
+        qt4_wrap_cpp(${ARGN})
+    endmacro()
+
+    set(MYGPO_QT_MAJOR_VERSION "")
+    set(MYGPO_QT4_QJSON_DEP "Requires.private: QJson")
+
+    # QJson is only required for Qt4
+    find_package(QJSON REQUIRED)
+endif()
+
 # Don't use absolute path in Mygpo-qtTargets-$buildType.cmake
 # (This will have no effect with CMake < 2.8)
-set(QT_USE_IMPORTED_TARGETS TRUE)
-
-find_package( Qt4 COMPONENTS QtCore QtNetwork QtTest REQUIRED )
-set( QT_DONT_USE_QTGUI TRUE )
-
-find_package(QJSON REQUIRED)
-
-include( ${QT_USE_FILE} )
+# set(QT_USE_IMPORTED_TARGETS TRUE)
 
 set( MYGPO_QT_VERSION_MAJOR "1" )
 set( MYGPO_QT_VERSION_MINOR "0" )
-set( MYGPO_QT_VERSION_PATCH "7" )
+set( MYGPO_QT_VERSION_PATCH "9" )
 set( MYGPO_QT_VERSION "${MYGPO_QT_VERSION_MAJOR}.${MYGPO_QT_VERSION_MINOR}.${MYGPO_QT_VERSION_PATCH}" )
 
 set( MYGPO_QT_SONAME "${MYGPO_QT_VERSION_MAJOR}")
@@ -62,7 +98,7 @@
 set(LIB_SUFFIX "" CACHE STRING "The directories where to install libraries to")
 set(LIB_INSTALL_DIR lib${LIB_SUFFIX} )
 set(LIB_DIR_PKGCONF "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}")
-set(INCLUDE_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/include/mygpo-qt" CACHE PATH "The directory the headers are installed in")
+set(INCLUDE_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/include/mygpo-qt${MYGPO_QT_VERSION_SUFFIX}" CACHE PATH "The directory the headers are installed in")
 set(CMAKECONFIG_INSTALL_DIR ${LIB_INSTALL_DIR}/cmake/mygpo-qt )
 
 if( APPLE )
@@ -97,11 +133,13 @@
     FIND_PACKAGE(PkgConfig)
     IF (PKG_CONFIG_FOUND)
         CONFIGURE_FILE (${CMAKE_CURRENT_SOURCE_DIR}/libmygpo-qt.pc.in
-                            ${CMAKE_CURRENT_BINARY_DIR}/libmygpo-qt.pc
+                            ${CMAKE_CURRENT_BINARY_DIR}/libmygpo-qt${MYGPO_QT_VERSION_SUFFIX}.pc
                             @ONLY)
-         INSTALL (FILES ${CMAKE_CURRENT_BINARY_DIR}/libmygpo-qt.pc DESTINATION lib${LIB_SUFFIX}/pkgconfig)
+         INSTALL (FILES ${CMAKE_CURRENT_BINARY_DIR}/libmygpo-qt${MYGPO_QT_VERSION_SUFFIX}.pc DESTINATION lib${LIB_SUFFIX}/pkgconfig)
     ENDIF (PKG_CONFIG_FOUND)
 ENDIF (NOT WIN32)
+
+set(MYGPO_QT_TARGET_NAME mygpo-qt${MYGPO_QT_VERSION_SUFFIX} CACHE INTERNAL "" FORCE )
 
 add_subdirectory( src )
 if(MYGPO_BUILD_TESTS)
@@ -114,7 +152,7 @@
 # This file contains add_library(bar IMPORTED) statements for each target in the export set, so
 # when loaded later on cmake will create "imported" library targets from these, which can be used
 # in many ways in the same way as a normal library target created via a normal add_library().
-install(EXPORT mygpo-qtExport DESTINATION ${CMAKECONFIG_INSTALL_DIR} FILE Mygpo-qtTargets.cmake )
+install(EXPORT ${MYGPO_QT_TARGET_NAME}Export DESTINATION ${CMAKECONFIG_INSTALL_DIR} FILE Mygpo-qt${MYGPO_QT_VERSION_SUFFIX}Targets.cmake )
 
 # figure out the relative path from the installed Config.cmake file to the install prefix (which may be at
 # runtime different from the chosen CMAKE_INSTALL_PREFIX if under Windows the package was installed anywhere)
@@ -124,12 +162,12 @@
 # Create a BarConfig.cmake file. <name>Config.cmake files are searched by find_package()
 # automatically. We configure that file so that we can put any information we want in it,
 # e.g. version numbers, include directories, etc.
-configure_file(Mygpo-qtConfig.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/Mygpo-qtConfig.cmake @ONLY )
+configure_file(Mygpo-qtConfig.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/Mygpo-qt${MYGPO_QT_VERSION_SUFFIX}Config.cmake @ONLY )
 
 # Additionally, when cmake has found a BarConfig.cmake, it can check for a BarConfigVersion.cmake
 # in the same directory when figuring out the version of the package when a version
 # has been specified in the find_package() call, e.g. find_package(Bar 1.0)
-configure_file(Mygpo-qtConfigVersion.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/Mygpo-qtConfigVersion.cmake @ONLY )
+configure_file(Mygpo-qtConfigVersion.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/Mygpo-qt${MYGPO_QT_VERSION_SUFFIX}ConfigVersion.cmake @ONLY )
 
 # Install these two files into the same directory as the generated exports-file.
-install(FILES ${CMAKE_CURRENT_BINARY_DIR}/Mygpo-qtConfig.cmake ${CMAKE_CURRENT_BINARY_DIR}/Mygpo-qtConfigVersion.cmake DESTINATION ${CMAKECONFIG_INSTALL_DIR} )
+install(FILES ${CMAKE_CURRENT_BINARY_DIR}/Mygpo-qt${MYGPO_QT_VERSION_SUFFIX}Config.cmake ${CMAKE_CURRENT_BINARY_DIR}/Mygpo-qt${MYGPO_QT_VERSION_SUFFIX}ConfigVersion.cmake DESTINATION ${CMAKECONFIG_INSTALL_DIR} )

=== example/Makefile ===
CC=g++
CFLAGS=-c -g -Wall $(shell pkg-config libmygpo-qt --cflags)
LIBS= $(shell pkg-config libmygpo-qt --libs)
SRCDIR=src

all: main

main: $(SRCDIR)/main.o 
	$(CC) $(SRCDIR)/main.o -o main $(LIBS)

qt5:
	$(CC) -c -I/home/horrendus/kde/include/mygpo-qt -I/usr/include/qt5/QtCore -I/usr/include/qt5 -I/usr/include/qt5/QtNetwork -fPIC $(SRCDIR)/main.cpp -o $(SRCDIR)/main_qt5.o
	$(CC) $(SRCDIR)/main_qt5.o -o main -L/home/horrendus/kde/lib -lmygpo-qt -lQt5Network -lQt5Core

$(SRCDIR)/main.o: $(SRCDIR)/main.cpp
	$(CC) $(CFLAGS) $(SRCDIR)/main.cpp -o $(SRCDIR)/main.o


make clean:
	rm -fr $(SRCDIR)/*.moc $(SRCDIR)/*.o main

=== tests/CMakeLists.txt ===
########### next target ###############
# QTEST_MAIN is using QApplication when QT_GUI_LIB is defined
remove_definitions(-DQT_GUI_LIB)
remove_definitions(-fvisibility=hidden)
remove_definitions(-DQT_NO_CAST_FROM_ASCII)
remove_definitions(-DQT_NO_CAST_TO_ASCII)

set ( TESTOBJECTS_SRCDIR ${CMAKE_CURRENT_SOURCE_DIR}/../src )

include_directories( ${QJSON_INCLUDE_DIR} ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_BINARY_DIR}/../src ${TESTOBJECTS_SRCDIR} )

# UrlBuilder library
add_library( UrlBuilder ${TESTOBJECTS_SRCDIR}/UrlBuilder.cpp ${TESTOBJECTS_SRCDIR}/Config.cpp )
qt5_use_modules( UrlBuilder Core )
# JSONCreator library
QT_WRAP_CPP(LIBMYGPO_QT_MOC_SRC ${TESTOBJECTS_SRCDIR}/EpisodeAction.h ${TESTOBJECTS_SRCDIR}/EpisodeAction_p.h )
add_library( JsonCreator ${TESTOBJECTS_SRCDIR}/JsonCreator.cpp ${TESTOBJECTS_SRCDIR}/EpisodeAction.cpp ${TESTOBJECTS_SRCDIR}/qjsonwrapper/Json.cpp ${LIBMYGPO_QT_MOC_SRC})
qt5_use_modules( JsonCreator Core Network )

set( EXECUTABLE_OUTPUT_PATH ${CMAKE_CURRENT_BINARY_DIR} )

macro(add_libmygpo_test _source)
    get_filename_component(_name ${_source} NAME_WE)
    QT_WRAP_CPP(${_name}_MOC_SRC ${_name}.h)
    add_executable(${_name} ${_source} ${${_name}_MOC_SRC})
    target_link_libraries(${_name} ${QT_QTCORE_LIBRARY} ${QT_QTTEST_LIBRARY} ${QT_QTNETWORK_LIBRARY})
    add_test(${_name}-test ${EXECUTABLE_OUTPUT_PATH}/${_name})
    qt5_use_modules(${_name} Network Test)
endmacro(add_libmygpo_test)

add_libmygpo_test( UrlBuilderTest.cpp )
target_link_libraries( UrlBuilderTest UrlBuilder)

add_libmygpo_test( JsonCreatorTest.cpp )
target_link_libraries( JsonCreatorTest JsonCreator ${QJSON_LIBRARIES} )

=== debian/changelog ===
libmygpo-qt (1.0.9-2) unstable; urgency=medium

  [ Pino Toscano ]
  * Enable parallel build. (Closes: #838227)
  * Install missing CMake config file. (Closes: #838229)

 -- Jérémy Bobbio <lunar@debian.org>  Sun, 04 Dec 2016 01:54:02 +0100

libmygpo-qt (1.0.9-1) unstable; urgency=medium

  * New upstream version.
  * Bump Standards-Version, no changes required.

 -- Jérémy Bobbio <lunar@debian.org>  Thu, 01 Dec 2016 14:44:15 +0100

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,10 @@
 Source: libmygpo-qt
 Section: kde
 Priority: optional
-Maintainer: Mike Elstad (v3g4n) <maintainer@mepiscommunity.org>
-XSBC-Original-Maintainer: Jérémy Bobbio <lunar@debian.org>
-Bugs: mailto: <maintainer@mepiscommunity.org>
+Maintainer: Jérémy Bobbio <lunar@debian.org>
 Build-Depends: debhelper (>= 9), cmake (>= 2.6), pkg-config, libqjson-dev,
  libqt4-dev, pkg-kde-tools
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Vcs-Git: https://anonscm.debian.org/git/collab-maint/libmygpo-qt.git
 Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/libmygpo-qt.git
 Homepage: http://wiki.gpodder.org/wiki/Libmygpo-qt

=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@ --parallel --with pkgkde_symbolshelper

=== debian/watch ===
version=4
http://stefan.derkits.at/files/libmygpo-qt/ \
    libmygpo-qt\.([\d\.]+)\.tar\.gz

## libmygpo-qt 1.0.9%7egit20151122

=== CMakeLists.txt ===
--- 
+++ 
@@ -54,7 +54,7 @@
 
 set( MYGPO_QT_VERSION_MAJOR "1" )
 set( MYGPO_QT_VERSION_MINOR "0" )
-set( MYGPO_QT_VERSION_PATCH "9" )
+set( MYGPO_QT_VERSION_PATCH "8" )
 set( MYGPO_QT_VERSION "${MYGPO_QT_VERSION_MAJOR}.${MYGPO_QT_VERSION_MINOR}.${MYGPO_QT_VERSION_PATCH}" )
 
 set( MYGPO_QT_SONAME "${MYGPO_QT_VERSION_MAJOR}")

## libmygpo-qt 1.1.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,16 +1,15 @@
-cmake_minimum_required( VERSION 2.6 FATAL_ERROR )
+cmake_minimum_required( VERSION 2.8.9 FATAL_ERROR )
 
 project( libmygpo-qt )
 
 set( CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules)
 set( CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -DQT_NO_CAST_FROM_ASCII -DQT_NO_CAST_TO_ASCII" )
 
-option(BUILD_WITH_QT4 "Build libmygpo-qt with Qt4 no matter if Qt5 was found" ON)
+option(BUILD_WITH_QT4 "Build libmygpo-qt with Qt4 no matter if Qt5 was found" OFF)
 
 if( NOT BUILD_WITH_QT4 )
     find_package(Qt5Core QUIET)
     if( Qt5Core_DIR )
-        message(STATUS "Found Qt5! Be aware that Qt5-support is still experimental and not officially supported!")
         set(MYGPO_QT_VERSION_SUFFIX 5)
 
         macro(qt_wrap_cpp)
@@ -26,6 +25,7 @@
 
 if( NOT Qt5Core_DIR )
     message(STATUS "Could not find Qt5, searching for Qt4 instead...")
+    message(STATUS "Qt4 Support is deprecated, building with Qt4 is no longer officially supported")
     if( MYGPO_BUILD_TESTS )
         find_package( Qt4 COMPONENTS QtCore QtNetwork QtTest REQUIRED )
     else( MYGPO_BUILD_TESTS )
@@ -53,8 +53,8 @@
 # set(QT_USE_IMPORTED_TARGETS TRUE)
 
 set( MYGPO_QT_VERSION_MAJOR "1" )
-set( MYGPO_QT_VERSION_MINOR "0" )
-set( MYGPO_QT_VERSION_PATCH "8" )
+set( MYGPO_QT_VERSION_MINOR "1" )
+set( MYGPO_QT_VERSION_PATCH "0" )
 set( MYGPO_QT_VERSION "${MYGPO_QT_VERSION_MAJOR}.${MYGPO_QT_VERSION_MINOR}.${MYGPO_QT_VERSION_PATCH}" )
 
 set( MYGPO_QT_SONAME "${MYGPO_QT_VERSION_MAJOR}")
@@ -99,7 +99,7 @@
 set(LIB_INSTALL_DIR lib${LIB_SUFFIX} )
 set(LIB_DIR_PKGCONF "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}")
 set(INCLUDE_INSTALL_DIR "${CMAKE_INSTALL_PREFIX}/include/mygpo-qt${MYGPO_QT_VERSION_SUFFIX}" CACHE PATH "The directory the headers are installed in")
-set(CMAKECONFIG_INSTALL_DIR ${LIB_INSTALL_DIR}/cmake/mygpo-qt )
+set(CMAKECONFIG_INSTALL_DIR ${LIB_INSTALL_DIR}/cmake/mygpo-qt${MYGPO_QT_VERSION_SUFFIX})
 
 if( APPLE )
     set( CPACK_GENERATOR "DragNDrop" )
@@ -114,7 +114,7 @@
 find_package(Doxygen)
 if(DOXYGEN_FOUND)
     configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile @ONLY)
-    add_custom_target(doc ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR} 
+    add_custom_target(doc ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
                          COMMENT "Generating API documentation with Doxygen" VERBATIM
 )
 endif(DOXYGEN_FOUND)

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 
-include_directories( ${QT_INCLUDES} ${QJSON_INCLUDE_DIR} ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR} )
+include_directories( ${QJSON_INCLUDE_DIR} ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR} )
 
 set ( LIBMYGPO_QT_SRC
         Config.cpp
@@ -21,6 +21,7 @@
         DeviceUpdates.cpp
         DeviceList.cpp
         Device.cpp
+        qjsonwrapper/Json.cpp
 )
 
 set ( LIBMYGPO_QT_MOC_H
@@ -74,12 +75,14 @@
         AddRemoveResult.h
 )
 
-QT4_WRAP_CPP(LIBMYGPO_QT_MOC_SRC ${LIBMYGPO_QT_MOC_H} )
+QT_WRAP_CPP(LIBMYGPO_QT_MOC_SRC ${LIBMYGPO_QT_MOC_H} )
 
-add_library( mygpo-qt SHARED ${LIBMYGPO_QT_SRC} ${LIBMYGPO_QT_MOC_SRC} )
+add_library( ${MYGPO_QT_TARGET_NAME} SHARED ${LIBMYGPO_QT_SRC} ${LIBMYGPO_QT_MOC_SRC} )
 
-target_link_libraries( mygpo-qt ${QJSON_LIBRARIES} ${QT_QTCORE_LIBRARY} ${QT_QTNETWORK_LIBRARY}  )
-set_target_properties( mygpo-qt PROPERTIES VERSION ${MYGPO_QT_VERSION} SOVERSION ${MYGPO_QT_SONAME} DEFINE_SYMBOL MYGPO_MAKEDLL)
-install( TARGETS mygpo-qt EXPORT mygpo-qtExport DESTINATION lib${LIB_SUFFIX} )
+target_link_libraries( ${MYGPO_QT_TARGET_NAME} ${QJSON_LIBRARIES} ${QT_QTCORE_LIBRARY} ${QT_QTNETWORK_LIBRARY}  )
+set_target_properties( ${MYGPO_QT_TARGET_NAME} PROPERTIES VERSION ${MYGPO_QT_VERSION} SOVERSION ${MYGPO_QT_SONAME} DEFINE_SYMBOL MYGPO_MAKEDLL)
+qt5_use_modules( ${MYGPO_QT_TARGET_NAME} Core Network )
 
-install( FILES ${LIBMYGPO_QT_INSTALL_H} DESTINATION  include/mygpo-qt COMPONENT Devel )
+install( TARGETS ${MYGPO_QT_TARGET_NAME} EXPORT ${MYGPO_QT_TARGET_NAME}Export DESTINATION ${LIB_INSTALL_DIR} )
+
+install( FILES ${LIBMYGPO_QT_INSTALL_H} DESTINATION  ${INCLUDE_INSTALL_DIR} COMPONENT Devel )

=== debian/changelog ===
libmygpo-qt (1.1.0-4) unstable; urgency=medium

  * Bump standard version to 4.5.0, no changes needed.
  * Update symbols files changes since GCC 10. (Closes: #957450, #964647).
  * Set debhelper compatibility to 13 using debhelper-compat in debian/control
    file.

 -- Thomas Pierson <contact@thomaspierson.fr>  Mon, 05 Oct 2020 09:03:40 +0200

libmygpo-qt (1.1.0-3) unstable; urgency=medium

  * Update symbols files changes since GCC 8. (Closes: #906484)
  * Add a patch to fix tests matching because of Qt::ISODate behavior change
    since Qt 5.11.
  * Update debian VCS repository urls to salsa.

 -- Thomas Pierson <contact@thomaspierson.fr>  Sun, 30 Sep 2018 10:57:14 +0200

libmygpo-qt (1.1.0-2) unstable; urgency=medium

  * Upload to unstable.

 -- Thomas Pierson <contact@thomaspierson.fr>  Thu, 17 May 2018 14:09:08 +0200

libmygpo-qt (1.1.0-1) experimental; urgency=medium

  * New upstream version.
  * Set myself as co-maintainer in debian/control.
  * Rewrite the build-depends in column and bump the standard version to
    4.1.4.
  * Force to build against QT5. (Closes: #875033)
  * Rename the binary package libmygpo-qt1 to libmygpo-qt5-1 and update the
    .install files.
  * Add a new symbols file based on the new soname and remove the old one.
  * Fix missing MYGPO_QT_VERSION_SUFFIX extension in fix-install-paths.patch.
  * Remove obsolete patch fix-expected-json.patch.
  * Replace libqt4-dev by qtbase5-dev in debian/control file.
  * Set cmake build-dependency to 2.8.9 and above.
  * Remove obsolete libqjson-dev build-dependency in debian/control.
    (Closes: #875319)

 -- Thomas Pierson <contact@thomaspierson.fr>  Wed, 02 May 2018 16:03:28 +0200

=== debian/control ===
Source: libmygpo-qt
Section: kde
Priority: optional
Maintainer: Jérémy Bobbio <lunar@debian.org>
Uploaders: Thomas Pierson <contact@thomaspierson.fr>
Build-Depends: cmake (>= 2.8.9),
               debhelper-compat (= 13),
               pkg-config,
               pkg-kde-tools,
               qtbase5-dev,
Standards-Version: 4.5.0
Vcs-Git: https://salsa.debian.org/thomaspi-guest/pkg-libmygpo-qt.git
Vcs-Browser: https://salsa.debian.org/thomaspi-guest/pkg-libmygpo-qt
Homepage: http://wiki.gpodder.org/wiki/Libmygpo-qt

Package: libmygpo-qt-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libmygpo-qt5-1 (= ${binary:Version}), ${misc:Depends},
         qtbase5-dev
Description: Development headers for the mygpo-qt library
 C++/Qt Library wrapping the gpodder.net Webservice
 .
 This package contains the development headers for the mygpo-qt library

Package: libmygpo-qt5-1
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: mygpo-qt library package
 C++/Qt Library wrapping the gpodder.net Webservice
 .
 This package contains the myqpo-qt library

=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@ --with pkgkde_symbolshelper

override_dh_auto_configure:
	dh_auto_configure -- \
	-DBUILD_WITH_QT4=OFF

## libmygpo-qt 1.1.0%2Bqtbuild

=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@ --parallel --with pkgkde_symbolshelper

override_dh_auto_configure:
	dh_auto_configure -- \
	-DBUILD_WITH_QT4=OFF

## libmygpo-qt 1.1.0+qtbuild

=== debian/changelog ===
libmygpo-qt (1.1.0+qtbuild-1+eagle) unstable; urgency=medium

  * update

 -- Jérémy Bobbio <lunar@debian.org>  Wed, 20 Jan 2021 09:49:11 +0800

=== debian/control ===
--- 
+++ 
@@ -4,11 +4,11 @@
 Maintainer: Jérémy Bobbio <lunar@debian.org>
 Uploaders: Thomas Pierson <contact@thomaspierson.fr>
 Build-Depends: cmake (>= 2.8.9),
-               debhelper-compat (= 13),
+               debhelper (>= 9),
                pkg-config,
                pkg-kde-tools,
                qtbase5-dev,
-Standards-Version: 4.5.0
+Standards-Version: 4.1.4
 Vcs-Git: https://salsa.debian.org/thomaspi-guest/pkg-libmygpo-qt.git
 Vcs-Browser: https://salsa.debian.org/thomaspi-guest/pkg-libmygpo-qt
 Homepage: http://wiki.gpodder.org/wiki/Libmygpo-qt
